<?php if(!defined('PLX_ROOT')) exit;
/** INCLUDED IN CONFIG.PHP
 * TOOLS FOR CONFIG mail Plugin plxSuperContact-1.1.1 for Pluxml
 * @author	SUDWEBDESIGN
 * Site : http://sudwebdesign.free.fr
 * Licence GNU_GPL
 **/
#src : github.com/ShakataGaNai/email-security-research/blob/master/check-domain-dns.php + DKIM //checkDomain('domain.com');//to use
function checkDomain($name){
	$out = dns_get_record($name, DNS_TXT);
	$spf = $dmarc = $dkim = false;
	foreach($out as $key){
		if( preg_match("/^v=spf(.*)/i", $key['txt'])){
			$spf = $key['txt'];
		}
	}

	$out2 = dns_get_record("_dmarc.".$name, DNS_TXT);
	foreach($out2 as $key){
		if( preg_match("/^v=dmarc(.*)/i", $key['txt'])){
			$dmarc = $key['txt'];
		}
	}

	$out3 = dns_get_record("_domainkey.".$name, DNS_TXT);
	foreach($out3 as $key){
		if( preg_match("/^v=DKIM(.*)/i", $key['txt'])){
			$dkim = $key['txt'];
		}
	}
	//return array($spf, $dmarc, $dkim);
	return "DOMAINNAME, SPF, DMARC, DKIM\n<br/>\"$name\", \"{$spf}\", \"{$dmarc}\", \"{$dkim}\"\n<br/>";
}

/** src : github.com/PHPMailer/PHPMailer/blob/master/examples/DKIM_gen_keys.phps
 * This shows how to make a new public/private key pair suitable for use with DKIM.
 * You should only need to do this once, and the public key (**not** the private key!)
 * you generate should be inserted in your DNS matching the selector you want.
 *
 * You can also use the DKIM wizard here: https://www.port25.com/support/domainkeysdkim-wizard/
 * but be aware that having your private key known anywhere outside your own server
 * is a security risk, and it's easy enough to create your own on your own server.
 *
 * For security, any keys you create should not be accessible via your web site.
 *
 * 2048 bits is the recommended minimum key length - gmail won't accept less than 1024 bits.
 * To test your DKIM config, use Port25's DKIM tester:
 * https://www.port25.com/support/authentication-center/email-verification/
 *
 * Note that you only need a *private* key to *send* a DKIM-signed message,
 * but receivers need your *public* key in order to verify it.
 *
 * Your public key will need to be formatted appropriately for your DNS and
 * inserted there using the selector you want to use.
#params
$domain//Set these to match your domain and chosen DKIM selector
$selector//from mailer generaly phpmailer
$privatekeyfile//Path to your private key file
$publickeyfile//Path to your public file
$type return text or html
$keep true see file link, false view private key
$refresh true to delete old key file to regenerate it
*
#config.php #memo
	$plxPlugin->setParam('use_dkim', $_POST['use_dkim'], 'numeric');
	$plxPlugin->setParam('dkim_domain', $_POST['dkim_domain'], 'string');
	$plxPlugin->setParam('dkim_private', $_POST['dkim_private'], 'string');
	$plxPlugin->setParam('dkim_selector', $_POST['dkim_selector'], 'string');
	$plxPlugin->setParam('dkim_passphrase', $_POST['dkim_passphrase'], 'string');
	$plxPlugin->setParam('dkim_extraheaders', $_POST['dkim_extraheaders'], 'string');
*/
function dkim(&$plxPlugin, $domain='example.com', $selector='phpmailer', $privatekeyfile='dkim_private', $publickeyfile='dkim_public', $type='text', $keep=true, $refresh=false){
	$EOL = $type!='text'?'<br/><br/>':PHP_EOL.PHP_EOL;
	if(!function_exists('openssl_pkey_new'))#Génère une nouvelle clé privée
		return $plxPlugin->getLang('L_DKIM_OPENSSL_PKEY_NEW_UNEXIST').$EOL.'<a target="_blank" href="https://www.dnswatch.info/dkim/create-dns-record">Online DNS Record Creation Tool for DKIM (www.dnswatch.info)</a>';#PHP Function openssl_pkey_new unexist! DKIM Keys Generator aborted!
	$privatekeyfile = $privatekeyfile . '_' . $domain . '.pem';
	$publickeyfile = $publickeyfile . '_' . $domain . '.pem';
	$return = '';//.dirname(__FILE__) . ' ' . dirname($publickeyfile) . ' ' . basename($publickeyfile) . $EOL;#debug
	if($refresh){
		if($refresh==='del'){
			$delmsg = $delParams = false;
			if(file_exists($privatekeyfile)){
				unlink($privatekeyfile);
				unlink($publickeyfile);
				$save = $plxPlugin->getParam('dkim_private');
				if(PLX_ROOT.$save == $privatekeyfile){#si c'est la clé sauvé
					$delParams = true;
				}
				$delmsg = $plxPlugin->getLang('L_DKIM_DEL') . ': '.$domain;
			}else{
				$delParams = true;
				$delmsg = $plxPlugin->getLang('L_DKIM_DEL_UNEXIST') . ': '.$domain;
			}
			if($delParams){
				$plxPlugin->setParam('dkim_domain','', 'string');#on efface le domaine
				$plxPlugin->setParam('dkim_private','', 'string');#on efface le chemin
				$plxPlugin->saveParams();#on enregistre la config
			}
			return $delmsg;
		}
		if(file_exists($privatekeyfile)){
			unlink($privatekeyfile);
			unlink($publickeyfile);
			$return .= $plxPlugin->getLang('L_DKIM_REFRESH');
		}
		$return .= $plxPlugin->getLang('L_DKIM_NEWS');
		$return .= ': ' . $domain . $EOL;
	}
	if (file_exists($privatekeyfile)) {
		$return .= $plxPlugin->getLang('L_DKIM_OLD_KEYS') . $EOL;
		$privatekey = file_get_contents($privatekeyfile);
		$publickey = file_get_contents($publickeyfile);
	} else {
		//Create a 2048-bit RSA key with an SHA256 digest
		$pk = openssl_pkey_new(
			array(
				'digest_alg' => 'sha256',
				'private_key_bits' => 2048,
				'private_key_type' => OPENSSL_KEYTYPE_RSA
			)
		);
		//Save private key
		openssl_pkey_export_to_file($pk, $privatekeyfile);
		//Save public key
		$pubKey = openssl_pkey_get_details($pk);
		$publickey = $pubKey['key'];
		file_put_contents($publickeyfile, $publickey);
		$privatekey = file_get_contents($privatekeyfile);
	}
	$publickeyfile = str_replace(PLX_ROOT,'',$publickeyfile);
	$privatekeyfile = str_replace(PLX_ROOT,'',$privatekeyfile);
	$return .= $plxPlugin->getLang('L_DKIM_PRIVATE') . ':' . $EOL . ($keep?$privatekeyfile:$privatekey);
	$return .= $EOL . $plxPlugin->getLang('L_DKIM_PUBLIC') . ':' . $EOL;
	if($type!='text') # html
		$return .= '<code><pre>' . $publickey . '</pre></code>' . $EOL;
	else #txt
		$return .= $publickey . $EOL;
	//Prep public key for DNS, e.g.
	//phpmailer._domainkey.example.com IN TXT "v=DKIM1; h=sha256; t=s; p=" "MIIBIjANBg...oXlwIDAQAB"...
	$dnskey = "$selector._domainkey.$domain IN TXT";
	//Some DNS server don't like ; chars unless backslash-escaped
	$dnsvalue = '"v=DKIM1\; h=sha256\; t=s\; p=" ';
	//Strip and split the key into smaller parts and format for DNS
	//Many DNS systems don't like long TXT entries
	//but are OK if it's split into 255-char chunks
	//Remove PEM wrapper
	$publickey = preg_replace('/^-+.*?-+$/m', '', $publickey);
	//Strip line breaks
	$publickey = str_replace(array("\r", "\n"), '', $publickey);
	//Split into chunks
	$keyparts = str_split($publickey, 253); //Becomes 255 when quotes are included
	//Quote each chunk
	foreach ($keyparts as $keypart) {
		$dnsvalue .= '"' . trim($keypart) . '" ';
	}
	$return .= $plxPlugin->getLang('L_DKIM_DNS_KEY') . ':' . $EOL . trim($dnskey) . $EOL;
	$return .= $plxPlugin->getLang('L_DKIM_DNS_VALUE') . ':' . $EOL . trim($dnsvalue);
	$_POST['dkim_private'] = $privatekeyfile;
	return $return;
}
